mage: golang:1.18

cache:
  paths:
    - .cache

before_script:
  - mkdir -p .cache
  - export GOPATH="$CI_PROJECT_DIR/.cache"

stages:
  - test
  - build
  - smoke-test
  - release

unit_tests:
  stage: test
  coverage: '/total:\s+\(statements\)\s+(\d+.\d+\%)/'
  script:
    - SKIPGEN=1 go test  -v -coverprofile=coverage.out ./...
    - go tool cover -func=coverage.out

lint_code:
  image: golangci/golangci-lint
  stage: test
  before_script:
    - go get mvdan.cc/gofumpt
  script:
    - golangci-lint run -v

build-docker:
  stage: build
  image: docker:stable
  only:
    - master
  services:
    - docker:19.03.5-dind
  variables:
    DOCKER_HOST: tcp://docker:2375
    DOCKER_DRIVER: overlay2
  before_script:
    - apk update
    - apk add make git jq curl
    - make docker-gitlab-login
  script:
    - make docker-gitlab-build
    - make docker-gitlab-push

release:
  stage: release
  image: registry.gitlab.com/thorchain/release-tool:latest
  only:
    - master
  except:
    - schedules
  script:
    - release-tool changelog